--Relay plugin by CrazySpence 0.2

local TCP = dofile("tcpsock.lua")

--User Vars --
local password = "changeme"
local server = "changeme.com"
--End user Vars--

local relay_handle = nil
local relay = 0


local function Connected(conn,success)
   if conn then
      print("Connected to Relay Server")
      conn:Send("REGISTER " .. "\"" .. GetPlayerName() .. "\"" .. " " .. password)
   else
      print(success)
      relay_handle = nil
   end
end

local function Disconnected()
   print("Connection to Relay Server interrupted")
   if relay_handle then
      relay_handle = nil
      relay = 0
   end
end

local function Incoming(conn,line)
   local output
   if line == "PING" then 
      relay_handle:Send("PONG")
   elseif line == "ACTIVATED" then
      relay = 1
   elseif string.sub(line,1,6) == "RELAY " then
      output = "say_guild " .. string.sub(line,6)
      gkinterface.GKProcessCommand(output)
   else
      print(line)
   end
end

local function relay_init()
   if not relay_handle then
      relay_handle = TCP.make_client("philtopia.com", "11000", Connected, Incoming, Disconnected)
   else 
      print("Relay is already connected")
   end
end

local function relay_stop()
   if relay_handle then
      relay_handle:Send("LOGOUT\n")
   end
end

local function relay_guild(event,data)
   if(relay == 1) then
      if(event == "CHAT_MSG_GUILD") then
         if not (string.sub(data.msg,1,4) == "[irc]") then
            relay_handle:Send("RELAY " .. "(guild) <" .. data.name .. ">" .. " " .. data.msg)
         end
      else
         if not (string.sub(data.msg,1,4) == "[irc]") then
            relay_handle:Send("RELAY " .. "(guild) * " .. data.name .. " " .. data.msg)
         end
      end
   end
end

RegisterUserCommand("relayon",relay_init)
RegisterUserCommand("relayoff",relay_stop)
RegisterEvent(relay_guild,"CHAT_MSG_GUILD")
RegisterEvent(relay_guild,"CHAT_MSG_GUILD_EMOTE")
